"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memorizer = void 0;
const defaultSize = 50000;
function memorizer(fn, size = defaultSize) {
    const cache = new Map();
    return (...args) => {
        const key = args.join('>!@[');
        if (!cache.has(key)) {
            if (cache.size >= size) {
                cache.clear();
            }
            cache.set(key, fn(...args));
        }
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        return cache.get(key);
    };
}
exports.memorizer = memorizer;
//# sourceMappingURL=Memorizer.js.map