declare function addToHeap<T>(t: T[], c: T, compare: (a: T, b: T) => number): void;
declare function takeFromHeap<T>(t: T[], compare: (a: T, b: T) => number): T | undefined;
export declare class SortedQueue<T> implements IterableIterator<T> {
    readonly compare: (a: T, b: T) => number;
    private values;
    constructor(compare: (a: T, b: T) => number);
    add(t: T): SortedQueue<T>;
    get length(): number;
    dequeue(): T | undefined;
    concat(i: Iterable<T>): SortedQueue<T>;
    next(): IteratorResult<T>;
    [Symbol.iterator](): IterableIterator<T>;
    clone(): SortedQueue<T>;
}
export declare const __testing__: {
    addToHeap: typeof addToHeap;
    takeFromHeap: typeof takeFromHeap;
};
export {};
