import * as Text from './util/text';
export declare const diagSource = "cSpell Checker";
import { CSpellUserSettings } from '@cspell/cspell-types';
import * as TV from './textValidator';
export { IncludeExcludeOptions } from './textValidator';
export interface ValidationIssue extends Text.TextOffset {
    suggestions?: string[];
}
export interface ValidateTextOptions {
    /** Generate suggestions where there are spelling issues. */
    generateSuggestions?: boolean;
    /** The number of suggestions to generate. The higher the number the longer it takes. */
    numSuggestions?: number;
}
export declare function validateText(text: string, settings: CSpellUserSettings, options?: ValidateTextOptions): Promise<ValidationIssue[]>;
export declare function settingsToValidateOptions(settings: CSpellUserSettings): TV.ValidationOptions;
export interface CheckTextInfo {
    text: string;
    items: TextInfoItem[];
}
export interface TextInfoItem {
    text: string;
    startPos: number;
    endPos: number;
    flagIE: IncludeExcludeFlag;
    isError?: boolean;
}
export declare enum IncludeExcludeFlag {
    INCLUDE = "I",
    EXCLUDE = "E"
}
export declare function checkText(text: string, settings: CSpellUserSettings): Promise<CheckTextInfo>;
